---
schema_version: "1"
id: 925f9e93866ccae1c825a6d1140bc25907131958e1fc3aa3d03b3a0ad5414052
title: Hierarchy API
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries/cme/guides/comms-t-hierarchy-api.md
canonical_url: https://developer.salesforce.com/docs/industries/cme/guide/comms-t-hierarchy-api.html
source_site: developer.salesforce.com
content_type: documentation
content_hash: 85fe71859b38fe5f0c8a47ae529ecd4410e653b148c7fb40e721620417b6bbd3
products:
  - Communications, Media, Energy and Utilities APIs (Managed Package)
  - Industries Developer Documentation
---
# Hierarchy API

The Hierarchy API takes a product's ID as input and populates its flat hierarchy in the cache. The hierarchy populated is the runtime hierarchy and not the admin time hierarchy. You must execute this API for each product offerId that you received in the response from the Catalog Profile API.

You can obtain the offerId required in the URI of this API from the apiResponse.data.catalogProductRelationDetails.Product node in the response body of the [Catalog Profile API](/docs/commerce/commerce/guide/comms-t-catalog-profile-api.html).

This API is for product Ids only. Do not use promotion Ids with this API. Promotions are handled by the Promotion Wrapper API.

## Precondition

You must first run the [Catalog Profile API](/docs/commerce/commerce/guide/comms-t-catalog-profile-api.html) to obtain the offerId required in the request body of this API.


## URI

/services/apexrest/{namespace}/v3/admin/catalogs/{catalogCode}/offers/{offerId}/hierarchy

## HTTP Method

POST

## URI Parameters

If you specify just one of these two parameters, it follows the behavior described in the table below and accepts your defined time for the parameter you specified. If you are using one or both parameters, you must specify them with the same values for all of the Populate Cache APIs in this sequence.

| Parameter          | Example             | Default                         | Optional/Required | Notes                                                                                                                                                                                                                                                                                                                              |
| ------------------ | ------------------- | ------------------------------- | ----------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| effectiveStartTime | 2001-07-04T12:08:56 | Current date and time           | Optional          | effectiveStartTime is the time that you want your cached catalog entries to be effective. It should be in the UTC date-time format. Your effectiveStartTime must occur after the current time for which you are executing the Populate Cache APIs or you will receive an error message.                                            |
| expirationTime     | 2001-07-04T12:08:56 | effectiveStartTime + TimeToLive | Optional          | expirationTime is the time that you want your cached catalog entries to expire. It should also be in the UTC date-time format. Your expirationTime must occur after your effectiveStartTime or you receive an error message. TimeToLive is a custom setting created in CPQ Configuration Setup. It has a default value of 30 days. |

Here is an example of how to pass the URI parameters:

```nolang
GET /services/apexrest/vlocity_cmt/v3/admin/catalogs/AS-Test-Catalog/hierarchy?effectiveStartTime=2021-07-04T12:08:56&expirationTime=2021-08-04T12:08:56
```

## Remote API

This is an example of how you invoke the API using Apex:

```nolang
String methodName;
String requestBodyJSON;
Map<String, Object> input = new Map<String, Object>();
Map<String, Object> output = new Map<String, Object>();
Map<String, Object> options = new Map<String, Object>();

// Setting remote parameters
methodName = 'getHierarchy';
input.put('apiName', 'CMHierarchy');        // required
input.put('methodName', methodName);        // required
input.put('catalogCode', 'TestCatalog');    // required
input.put('offerId', '01t4x000000x269AAA'); // required
input.put('effectiveStartTime', null);      // optional
input.put('expirationTime', null);          // optional
input.put('requestURL', '/v3/admin/catalogs/{catalogCode}/offers/{offerId}/hierarchy'); //required

//remote action invocation
vlocity_cmt.CpqAppHandler appHandler = new vlocity_cmt.CpqAppHandler();
appHandler.invokeMethod(methodName, input, output, options);
```

## Parallel Invocation

This API can run in parallel for multiple offers. For example, if there are 10 catalogs (Catalog1, Catalog2..Catalog 10) and each catalog has 100 offers, you can run this API for all 1,000 offers in parallel threads.

```nolang
THREAD1 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog1/offers/offer1/hierarchy
THREAD2 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog1/offers/offer2/hierarchy
......
THREAD100 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog1/offers/offer100/hierarchy
THREAD101 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog2/offers/offer101/hierarchy
......
THREAD1000 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog10/offers/offer1000/hierarchy
```

## HTTP Headers

| Header       | Description      |
| ------------ | ---------------- |
| Content-Type | application/json |

## Response Body

This example shows product offer IDs.

```
[
  "01t5g000002vVPdAAM",
  "01t5g000002vVQmAAM",
  "01t5g000002vVF2AAM"
]
```

## HTTP Response Codes

| Code | Description           |
| ---- | --------------------- |
| 200  | OK                    |
| 500  | Internal Server Error |
